{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X-}
{$M 16384,0,655360}

program Draw3rd;


 uses

   CRT,
   Graph,
   Graph3rd;


 const

   VideoBuf        : pointer = ptr($B800, $0000);
   CountX          = 50;
   CountY          = 30;


 var

   F                         : file;
   B                         : array [1..20] of pointer;
   H, L                      : array [0..1, 0..639] of integer;
   X, Y, Fi, dX, dY, dFi     : real;
   bX, bY                    : real;
   GD, GM, I, SX, SY         : integer;


 procedure CGAProc; external;
  {$L CGA.Obj}

 function Z        (X, Y, Fi : real) : real;
  var
    R              : real;
  begin
    R              := Sqrt(X * X + Y * Y);
    Z              := Sin(R - Fi) / (R + 1);
  end;

 procedure PopUpLineTo       (X, Y : integer; HN : byte);
  var
    cX, cY, dX, dY, sX, sY, E, I       : integer;
    Swap                               : boolean;
  begin
    cX             := GetX;
    cY             := GetY;
    MoveTo         (X, Y);
   if not((H[HN, cX] < cY) and (L[HN, cX] > cY) and
          (H[HN,  X] <  Y) and (L[HN,  X] >  Y))
   then begin
          dX       := Abs(X - cX);
          dY       := Abs(Y - cY);
         if dX = 0
         then
           sX      := 0
         else
           sX      := (X - cX) div dX;
         if dY = 0
         then
           sY      := 0
         else
           sY      := (Y - cY) div dY;
         if (((H[HN, cX] > cY) or (H[HN, X] > Y)) and (sY = 1)) or
            (((L[HN, cX] < cY) or (L[HN, X] < Y)) and (sY = -1))
         then begin
                cX           := X;
                cY           := Y;
                sX           := -sX;
                sY           := -sY;
              end;
         if dY > dX
         then begin
                E            := dX;
                dX           := dY;
                dY           := E;
                Swap         := true;
              end
         else
           Swap    := false;
          E        := 2 * dY - dX;
         for I := 0 to dX do
         begin
          if H[HN, cX] > cY
          then begin
                 PutPixel    (cX, cY, 1);
                 H[HN, cX]   := cY;
               end;
          if L[HN, cX] < cY
          then begin
                 PutPixel    (cX, cY, 1);
                 L[HN, cX]   := cY;
               end;
          while E >= 0 do
          begin
           if Swap
           then
             inc   (cX, sX)
           else
             inc   (cY, sY);
            dec    (E, 2*dX);
          end;
          if Swap
          then
            inc    (cY, sY)
          else
            inc    (cX, sX);
           inc     (E, 2*dY);
         end;
        end;
  end;


 begin
   if RegisterBGIDriver(@CGAProc) = 0 then;
   GD              := CGA;
   GM              := CGAHi;
   InitGraph       (GD, GM, '');
   cmSetDirectVector         (0, 1, 1);
   cmSetMinX       (-18);
   cmSetMinY       (-18);
   cmSetMinZ       (-0.5);
   cmSetMaxX       (18);
   cmSetMaxY       (18);
   cmSetMaxZ       (0.5);
   cmRotateXY      (Pi / 5);
   dX              := Pi * 8 / CountX;
   dY              := Pi * 8 / CountY;
   dFi             := Pi / 10;
   Fi              := 0;
   bX              := 2 * Pi;
   bY              := 2 * Pi;
   Assign          (F, 'Graph3rd.Pic');
   ReWrite         (F, 1);
  for I := 1 to 20 do
  begin
    ClearViewPort;
    FillChar       (L, SizeOf(L), $00);
    FillChar       (H, SizeOf(H), $7F);
    Y              := -4 * Pi;
   for GD := 0 to CountY do
   begin
     X             := 4 * Pi;
     cmMoveTo3rd   (bX+X/2, bY+Y/2, 0.5+Z(X, Y, Fi)/2);
    for GM := 1 to CountX do
    begin
      X            := X - dX;
      cm3rdTo2nd   (bX+X/2, bY+Y/2, 0.5+Z(X, Y, Fi)/2, SX, SY);
      PopUpLineTo  (SX, SY, 0);
    end;
     X             := -4 * Pi;
     cmMoveTo3rd   (bY-Y/2, bX+X/2, 0.5+Z(-Y, X, Fi)/2);
    for GM := 1 to CountX do
    begin
      X            := X + dX;
      cm3rdTo2nd   (bY-Y/2, bX+X/2, 0.5+Z(-Y, X, Fi)/2, SX, SY);
      PopUpLineTo  (SX, SY, 1);
    end;
     Y             := Y + dY;
   end;
    Fi             := Fi + dFi;
    GetMem         (B[I], $4000);
    Move           (VideoBuf^, B[I]^, $4000);
    BlockWrite     (F, B[I]^, $4000);
  end;
    Close          (F);
  while not KeyPressed do
  begin
   for I := 1 to 20 do
   begin
     Move          (B[I]^, VideoBuf^, $4000);
     Delay         (80);
   end;
  end;
   I               := Ord(ReadKey);
   CloseGraph;
 end.